--
--Taunt Tattle Rehashed
--Author: Kasani - Agamaggan-US
--Original: CasualCorps
--
--Updated to 50001 to include more taunts, and add monk taunts
--Added announcing to party or raid, depending on which you're in
--
	versiontext = "v1.0.3";
	prefixtext="[Taunt Tattle Rehashed]: ";
  if isEnabled == nil then
   isEnabled = true; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isSelfOnly == nil then
   isSelfOnly = false; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isIgnMT == nil then
   isIgnMT = false; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isInGroup == nil then
   isInGroup = true; -- This is the first time this addon is loaded; initialize the count to 0.
  end

  SLASH_TTR1 = '/ttr'; -- 3.
function SlashCmdList.TTR(msg, editbox) -- 4.
	if (isEnabled == nil or isEnabled == true) then
		isEnabledText = "On";
		else
		isEnabledText = "Off";
	end
	if (isSelfOnly == nil or isSelfOnly == false) then
		isSelfOnlyText = "Off";
		else
		isSelfOnlyText = "On";
	end
	if (isIgnMT == nil or isIgnMT == false) then
		isIgnMTText = "Off";
		else
		isIgnMTText = "On";
	end
	if (isInGroup == nil or isInGroup == true) then
		isInGroupText = "On";
		else
		isInGroupText = "Off";
	end
	--print(msg);
if (msg == nil or msg == "") then
	print("[Taunt Tattle Rehashed] "..versiontext.." by Kasani - Agamaggan-US\n  Option Commands are listed below\n  Toggle Announcements ("..isEnabledText.."): /ttr toggle (/ttr tg)\n  Toggle Self Only Mode ("..isSelfOnlyText.."): /ttr selfonly (/ttr so)\n  Toggle Ignore Main Tank Mode ("..isIgnMTText.."): /ttr ignoremt (/ttr imt)\n  Toggle In Party Mode ("..isInGroupText.."): /ttr inparty (/ttr ip)");
elseif (msg == "toggle" or msg == "tg") then
	if(isEnabled == false) then
		isEnabled = true;
		print("[Taunt Tattle Rehashed] is now Enabled.");
	else
		isEnabled = false;
		print("[Taunt Tattle Rehashed] is now Disabled.");
	end
	
	
elseif (msg == "self only" or msg == "selfonly" or msg == "so") then
	if(isSelfOnly == false) then
		isSelfOnly = true;
		print("[Taunt Tattle Rehashed] Announcements will now only send to you.");
	else
		isSelfOnly = false;
		print("[Taunt Tattle Rehashed] Announcements will now send to party or raid.");
	end
	
	
elseif (msg == "ignore main tank" or msg == "ignore mt" or msg == "ignoremaintank" or msg == "ignoremt" or msg == "imt") then
	if(isIgnMT == false) then
		isIgnMT = true;
		print("[Taunt Tattle Rehashed] Announcements will now ignore players marked as 'Tank'.");
	else
		isIgnMT = false;
		print("[Taunt Tattle Rehashed] Announcements will now send all taunts.");
	end
	
	
elseif (msg == "in party" or msg == "inparty" or msg == "ip") then
	if(isInGroup == false) then
		isInGroup = true;
		print("[Taunt Tattle Rehashed] Announcements will now check if source is in party or raid.");
	else
		isInGroup = false;
		print("[Taunt Tattle Rehashed] Announcements will now include all sources.");
	end

end

end

function TauntTattleFrame_OnLoad()

 --TTRAddon = {};
 --TTRAddon.panel = CreateFrame( "Frame", "TauntTattleOptionsFrame", UIParent );
 -- Register in the Interface Addon Options GUI
 -- Set the name for the Category for the Options Panel
 --TTRAddon.panel.name = "Taunt Tattle Rehashed";
 -- Add the panel to the Interface Options
 --InterfaceOptions_AddCategory(TTRAddon.panel);

	TauntTattleFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");


	ChatFrame1:AddMessage("|cffffff00 Taunt Tattle Rehashed Loaded. Type /ttr for options.");

	-- already hidden by default, but just in case...
	TauntTattleFrame:Hide();
end

function TauntTattleFrame_OnEvent(event, ...)
if (isEnabled == true) then
	local timestamp, ttype, hideCaster, srcGUID, srcName, srcFlags, sourceRaidFlags, dstGUID, dstName, dstFlags, destRaidFlags, spellid, spellname, spellschool, targetchan, isGo, b_or_d = select(1, ...);
	
	--ChatFrame1:AddMessage("Spell Detected: "..srcName.." -> "..spellid.." -> "..spellname.." -> "..dstName);
	--if (spellid == 51399) then
		--print("DG Taunt: "..ttype);
	--end
	--if ((ttype == "SPELL_CAST_SUCCESS") or (ttype == "SPELL_AURA_APPLIED")) and (
	if ((ttype == "SPELL_CAST_SUCCESS") and (
			--Warrior
		(spellid == 355) or --Taunt
		(spellid == 114192) or --Mocking Banner
			--Paladin
		(spellid == 31789) or --Righteous Defense
		(spellid == 62124) or --Reckoning
			--Druid
		(spellid == 6795) or --Growl
			--Death Knight
		--(spellid == 49576) or --Death Grip (Pull)
		(spellid == 56222) or --Dark Command
			--Monk
		(spellid == 115546) or --Provoke
		(spellid == 115180) or --Dizzying Haze
			--Warlock
		(spellid == 97827) or  --Provocation
			--Shaman
		(spellid == 73684) or  --Unleash Elements - Rockbiter
			--Hunter
		(spellid == 2649) or  --Pet - Growl
			
		
			--Legacy or Unknown
		(spellid == 5209) or 
		(spellid == 1161) or 
		(spellid == 694)
	)) or ((ttype == "SPELL_AURA_APPLIED") and (
			--Death Knight
		(spellid == 49560) or --Death Grip (Taunt)
		(spellid == 51399) --Death Grip (Taunt) 
		
		
	)) then
	--ChatFrame1:AddMessage("Spell Confirmed: "..srcName.." -> "..spellid.." -> "..spellname.." -> "..dstName);


	isGo = false;
	if ( isSelfOnly == false ) then
		if ( IsInRaid() == true ) then
			targetchan = "RAID";
			isGo = true;
			inParty = UnitPlayerOrPetInRaid(srcName);
		elseif ( IsInGroup() == true ) then
			targetchan = "PARTY";
			isGo = true;
			inParty = UnitPlayerOrPetInParty(srcName);
		end
	else 
		if ( IsInRaid() == true ) then
			isGo = false;
			inParty = UnitPlayerOrPetInRaid(srcName);
		elseif ( IsInGroup() == true ) then
			isGo = false;
			inParty = UnitPlayerOrPetInParty(srcName);
		end
	end
	
	--ChatFrame1:AddMessage("isGo is "..isGo.." - "..GetNumGroupMembers());

	--isAssigned = GetPartyAssignment("TANK");
	isAssigned = UnitGroupRolesAssigned(srcName);
	--print(srcName.." - "..inParty);
	
	if ( isAssigned == "TANK" and isIgnMT == true ) then
		--print("    IGNORED");
	
	elseif (isInGroup == true and inParty == nil and (IsInGroup() or IsInRaid())) then
		--print("    IGNORED IP");
	
	else
	if (isGo == true) then
		if (dstName) then
			SendChatMessage(prefixtext..spellname.." used to taunt "..dstName.." by ".. srcName, targetchan);
		else
			SendChatMessage(prefixtext..spellname.." used by ".. srcName, targetchan);
		end
	else
		if (dstName) then
			ChatFrame1:AddMessage(prefixtext..spellname.." used to taunt "..dstName.." by ".. srcName);
		else
			ChatFrame1:AddMessage(prefixtext..spellname.." used by ".. srcName);
		end
	end
	end

	end
	
end

end